// import the video library 
import processing.video.*;

// this is the video capturing object
Capture cam;

void setup() {
  // try 640 x 480 too
  size(320, 240);

  // use default camera (see 'video' demo and 
  // slides if this doesn't work) 
  cam = new Capture(this, 320, 240);
  cam.start();
}


void draw() {

  cam.loadPixels();

  // brightest position
  int brightestX = 0;
  int brightestY = 0;
  // brightest value
  float brightest = 0;

  for (int y = 0; y < cam.height; y++) {
    for (int x = 0; x < cam.width; x++) {

      int i = x + y * cam.width;
      float b = brightness(cam.pixels[i]);

      // update brightest position
      if (b > brightest && b > 200) {
        brightest = b;
        brightestX = x;
        brightestY = y;
      }
    }
  }


  image(cam, 0, 0);

  // draw shape at brightest position

  fill(255, 200);
  ellipse(brightestX, brightestY, 100, 100);
} 

// event function for video
// (called everytime there's a new frame)
void captureEvent(Capture cam) {
  cam.read();
}