// import the video library 
import processing.video.*;

// this is the video capturing object
Capture cam;

void setup() {
  // try 640 x 480 too
  size(320, 240);

  // use default camera (see 'video' demo and 
  // slides if this doesn't work) 
  cam = new Capture(this, 320, 240);
  cam.start();

}


color trackColour = color(79,22,22);
boolean showImage = true;

void draw() {

    if (showImage) {
      image(cam, 0, 0);
    } else {
      background(0);
    }

    cam.loadPixels();

    // position of closest hue
    int closestX = 0;
    int closestY = 0;
    // start closest distance to the hue very high
    float closestDist = 1000;

    for (int y = 0; y < cam.height; y++) {
      for (int x = 0; x < cam.width; x++) {

        int i = x + y * cam.width;

        // see how far it is from the hue we want to track
        // (abs is the absolute difference)
        float d = abs(trackColour-cam.pixels[i]); 

        // if it's closer that all the other pixels
        // then update this as the closest pixel found so far
        if (d < closestDist ) {
          closestDist = d;
          closestX = x;
          closestY = y;
        }
      }
    }

    // draw shape at position that was closest
    fill(255, 0,0);
    ellipse(closestX, closestY, 100, 100);
} 

// pick what colour to track
void mousePressed() {
  // get corresponding pixel in video frame
  int i = mouseX + mouseY * cam.width;
  trackColour = color(cam.pixels[i]);
  println(red(trackColour),green(trackColour),blue(trackColour));
}

void keyPressed() {
  // show or hide the frame
  showImage = !showImage;
}

// event function for video
// (called everytime there's a new frame)
void captureEvent(Capture cam) {
  cam.read();
}