// import the video library 
import processing.video.*;

// this is the video capturing object
Capture cam;

// maximum grid cell size (try changing this)
int maxSize = 6;

void setup() {

  // create a canvas with same size as video
  size(320, 240);

  // use default camera (see 'video' demo and 
  // slides if this doesn't work) 
  cam = new Capture(this, 160, 120);
  cam.start();

  noStroke();
}


void draw() {

  background(0);

  // loop through all grid positions
  for (float x = maxSize / 2; x < width; x += maxSize) {
    for (float y = maxSize / 2; y < height; y += maxSize) {

      // get the colour at the corresponding pixel
      int vx = int(map(x, 0, width - 1, 0, cam.width - 1));
      int vy = int(map(y, 0, height - 1, 0, cam.height - 1));
      color pixelColour = cam.get(vx, vy);

      // get brightness and convert it to a size
      float b = brightness(pixelColour);
      float s = map(b, 0, 255, 0, maxSize * 1.5);

      fill(255);
      ellipse(x, y, s, s);
    }
  }
} 

// event function for video
// (called everytime there's a new frame)
void captureEvent(Capture cam) {
  cam.read();
}