// import the video library 
import processing.video.*;

// this is the video capturing object
Capture cam;

void setup() {

  // create a canvas with same size as video
  size(320, 240);

  // use default camera (see 'video' demo and 
  // slides if this doesn't work) 
  cam = new Capture(this, 320, 240);
  cam.start();

  background(0);
  noStroke();
}

void draw() {

  // draw 200 random pixels from video frame
  for (int i = 0; i < 250; i++) {

    // random location in image and canvas
    // (they're both the exact same size)
    int x = int(random(0, width - 1));
    int y = int(random(0, height - 1));

    color pixelColour = cam.get(x, y);
    
    fill(pixelColour, 200);
    int size = int(random(1, 5));
    ellipse(x, y, size, size);
  }
} 

// event function for video
// (called every time there's a new frame)
void captureEvent(Capture cam) {
  cam.read();
}