// import the video library 
import processing.video.*;

// this is the video capturing object
Capture cam;

void setup() {
  // try 640 x 480 too
  size(320, 240);

  // use default camera (see 'video' demo and 
  // slides if this doesn't work) 
  cam = new Capture(this, width, height);
  cam.start();
}


void draw() {

  image(cam, 0, 0);

  loadPixels();
  for (int y = 0; y < height; y++) {
    for (int x = 0; x < width; x++) {

      int i = x + y * width;
      color pixelColour = pixels[i];

      // extract red, green, and blue parts
      float r = red(pixelColour);
      float g = green(pixelColour);
      float b = blue(pixelColour);

      // image processing here
      float d = dist(mouseX, mouseY, x, y);
      float f = map(d, 0, 80, 1.0, 0);
      pixels[i] = color(r * f, g * f, b * f);
    }
  }
  updatePixels();
} 

// event function for video
// (called everytime there's a new frame)
void captureEvent(Capture cam) {
  cam.read();
}